%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%define refmac_dictionary %(rpm -q --queryformat '%%{name}-%%{version}' refmac-dictionary)

Name: coot
Summary: The crystallographic object-oriented toolkit
URL: http://www2.mrc-lmb.cam.ac.uk/personal/pemsley/coot/
Version: 0.8.1
Release: 1%{?dist}
# source code is mixed GPLv3+ and LGPLv2+ (see %files for breakdown)
License: GPLv3+ and LGPLv2+
Group: Applications/Engineering
Source0: http://www2.mrc-lmb.cam.ac.uk/Personal/pemsley/coot/source/releases/%{name}-%{version}.tar.gz
Source1: http://www2.mrc-lmb.cam.ac.uk/personal/pemsley/coot/dependencies/reference-structures.tar.gz
Source2: coot.in
Source3: %{name}.desktop
Source4: __init__.py
Patch0: coot-configure.in.patch
Patch1: coot-user-manual.texi.patch
Patch2: coot-makefile.patch
Patch3: coot-guile.patch
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: clipper-devel >= 2.1-7
BuildRequires: desktop-file-utils
BuildRequires: libappstream-glib
BuildRequires: freeglut-devel
BuildRequires: goocanvas-devel
BuildRequires: gsl-devel
BuildRequires: gtk2-devel
BuildRequires: gtkglext-devel
BuildRequires: compat-guile18-devel
BuildRequires: guile-lib
BuildRequires: imlib-devel
BuildRequires: libcurl-devel
BuildRequires: libgnomecanvas-devel
BuildRequires: libtool
BuildRequires: mmdb2-devel
BuildRequires: python-devel
BuildRequires: pygtk2-devel
BuildRequires: refmac-dictionary
BuildRequires: ssm-devel
BuildRequires: swig
%if 0%{?rhel}
BuildRequires: tetex-latex
%else
BuildRequires: tex(latex)
%endif
BuildRequires: texinfo-tex
BuildRequires: ghostscript
Requires: compat-guile18
Requires: refmac-dictionary

%description

Coot is a toolkit for Macromolecular Crystallography and
model-building.  Coot uses professional (and free) widgets (with the
GUI builder glade), mmdb, clipper, and OpenGL, together with a new
approach to map contouring and importing/creation and other modeling
and building operations.

%package devel
Summary: Header files and library for developing programs with coot
Requires: %{name} = %{version}-%{release}
Group: Development/Libraries

%description devel

This package contains libraries and header files needed for program
development using the coot macromolecular model building package.

%package doc
Summary: documentation PDF files for coot
Requires: %{name} = %{version}-%{release}
Group: Applications/Engineering

%description doc

the coot-doc package contains information concerning the use and
button/key shortcuts for the coot macromolecular model building
package.

%prep
%setup -q -a 1
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0

cp %{SOURCE2} ./src/
cp %{SOURCE3} .

# various cleanups
iconv -f iso8859-1 -t utf-8 README > README.conv && mv -f README.conv README

aclocal -I macros
libtoolize --automake --copy
autoconf
automake --copy --add-missing --gnu

%build
mkdir guile
%configure --with-guile --with-python --with-pygtk --with-goocanvas-prefix=/usr --disable-static CPPFLAGS="-I/usr/include/mmdb2 -I/usr/include/ssm" CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" GUILE_LOAD_PATH="$GUILE_LOAD_PATH:/tmp/guile"
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

make %{?_smp_mflags}
pushd doc
texi2pdf coot-user-manual.texi
make coot-keys-and-buttons.pdf
popd

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot} INSTALL='install -p'

mv reference-structures %{buildroot}%{_datadir}/coot/

sed -i 's|COOT_PYTHON_DIR=|COOT_PYTHON_DIR=%{python_sitelib}/coot|' src/coot
sed -i 's|COOT_REFMAC_LIB_DIR=|COOT_REFMAC_LIB_DIR=%{_datadir}/%{refmac_dictionary}|' src/coot
install -p -m 755 src/coot %{buildroot}%{_bindir}/

# remove unpackaged files from the buildroot
rm -f %{buildroot}%{_libdir}/*.la

# headers
# mkdir %{buildroot}%{_includedir}/coot
# mv %{buildroot}%{_includedir}/*.h %{buildroot}%{_includedir}/coot/
# mv %{buildroot}%{_includedir}/*.hh %{buildroot}%{_includedir}/coot/

# python stuff
# mkdir -p %{buildroot}%{python_sitelib}/coot
# mv %{buildroot}%{_datadir}/coot/python/* %{buildroot}%{python_sitelib}/coot/
for lib in $(find %{buildroot}%{python_sitelib}/coot/ -name "*.py"); do
 sed '/\/usr\/bin\/env/d' $lib > $lib.new &&
 touch -r $lib $lib.new &&
 mv $lib.new $lib
done
cp %{SOURCE4} %{buildroot}%{python_sitelib}/coot/
chmod 644 %{buildroot}%{python_sitelib}/coot/coot.py

# desktop file
desktop-file-install --vendor='' --dir=%{buildroot}%{_datadir}/applications coot.desktop
appstream-util validate-relax --nonet %{buildroot}/%{_datadir}/appdata/*.appdata.xml

%clean
rm -rf %{buildroot}

%check
make check
# %{buildroot}%{_bindir}/coot-real --no-graphics --script python-tests/coot_unittest.py

%post
/sbin/ldconfig
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
/sbin/ldconfig
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

%files
%defattr(-,root,root,-)
%doc AUTHORS README COPYING
%{_bindir}/*
%{_libexecdir}/*
# libccp4mg-utils.so* is LGPLv2+
# libcoot-surface.so* is a mix of LGPLv2+ and GPLv3+
# all others are GPLv3+ 
%{_libdir}/*.so.*
%{_datadir}/coot/
%{_datadir}/applications/%{name}.desktop
%{_datadir}/appdata/%{name}.appdata.xml
%{_datadir}/icons/hicolor/scalable/apps/hicolor_apps_scalable_coot.svg
%{python_sitelib}/coot/

%files devel
%defattr(-,root,root,-)
%{_libdir}/*.so
%{_includedir}/coot/

%files doc
%defattr(-,root,root,-)
%doc doc/coot-keys-and-buttons.pdf doc/coot-user-manual.pdf

%changelog
* Sat Jan 31 2015 Tim Fenn <tim.fenn@gmail.com> - 0.8.1-1
- update to 0.8.1
- update URL
- no sxml support in guile 1.8 (remove AM_GUILE_LIB check)
- add gtk update icon cache scriptlets
- add appdata xml file and additional app-data-validate scripts

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Dec 27 2013 Tim Fenn <tim.fenn@gmail.com> - 0.7.2-1
- update to 0.7.2
- update upstream URLs, no longer using vcs

* Sun Aug 11 2013 Tim Fenn <tim.fenn@gmail.com> - 0.7-5.20120929svn4458
- add ghostscript to buildrequires

* Fri Aug 09 2013 Tim Fenn <tim.fenn@gmail.com> - 0.7-4.20120929svn4458
- use xz instead of gz (BZ 982385)
- update for soname bump in deps (BZ 989141)
- use guile1.8-compat, add guile requires

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-3.20120929svn4458
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-2.20120929svn4458
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Sep 29 2012 Tim Fenn <tim.fenn@gmail.com> - 0.7-1.20120929svn4458
- update to 0.7

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.2-14.20110715svn3566
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Feb 28 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.2-13.20110715svn3566
- Rebuilt for c++ ABI breakage

* Sat Jan 14 2012 Tim Fenn <tim.fenn@gmail.com> - 0.6.2-12.20110715svn3566
- patches to fix unistd.h issue and compilation errors

* Thu Jan 12 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.2-11.20110715svn3566
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sat Dec 10 2011 Tim Fenn <tim.fenn@gmail.com> - 0.6.2-10.20110715svn3566
- patch for new libpng

* Tue Dec 06 2011 Adam Jackson <ajax@redhat.com> - 0.6.2-9.20110715svn3566
- Rebuild for new libpng

* Fri Jul 15 2011 Tim Fenn <fenn@stanford.edu> - 0.6.2-8.20110715svn3566
- update to SVN 3566 (0.6.2 final)

* Tue Apr 26 2011 Tim Fenn <fenn@stanford.edu> - 0.6.2-7.20110421svn3461
- add reference structures source file

* Tue Apr 26 2011 Tim Fenn <fenn@stanford.edu> - 0.6.2-6.20110421svn3461
- add missing source

* Thu Apr 21 2011 Tim Fenn <fenn@stanford.edu> - 0.6.2-5.20110421svn3461
- update to SVN 3461
- fix missing Requires: guile-lib

* Tue Mar 29 2011 Tim Fenn <fenn@stanford.edu> - 0.6.2-4.20110328svn3442
- update to SVN 3442 (should remove guile-gtk broken dependencies)

* Fri Feb 25 2011 Tim Fenn <fenn@stanford.edu> - 0.6.2-3.20110225svn3399
- update to SVN 3399

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.2-2.20101012svn3213
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Oct 12 2010 Tim Fenn <fenn@stanford.edu> - 0.6.2-1.20101012svn3213
- update to 0.6.2

* Thu Aug 05 2010 Tim Fenn <fenn@stanford.edu> - 0.6.1-3.20100127svn2740
- fix file attr
- add comment to make check error

* Tue Jul 20 2010 Tim Fenn <fenn@stanford.edu> - 0.6.1-2.20100127svn2740
- move some documentation to subpackage
- add check section

* Wed Jan 27 2010 Tim Fenn <fenn@stanford.edu> - 0.6.1-1.20100127svn2740
- update to SVN 2740, 0.6.1 release
- add curl buildrequires

* Thu Dec 03 2009 Tim Fenn <fenn@stanford.edu> - 0.6-6.20091203svn2545
- update to SVN 2545, 0.6 release

* Mon Nov 30 2009 Tim Fenn <fenn@stanford.edu> - 0.6-5.20091130svn2528
- fix texi, include user-manual
- update to SVN 2528
- remove net-http, guile-goosh and guile-gui

* Wed Oct 07 2009 Tim Fenn <fenn@stanford.edu> - 0.6-4.20091007svn2404
- update buildrequires
- use tetex-latex on EL builds
- update to SVN 2404 (fixes some licensing issues)

* Mon Oct 05 2009 Tim Fenn <fenn@stanford.edu> - 0.6-3.20091005svn2400
- update to SVN 2400

* Wed Sep 23 2009 Tim Fenn <fenn@stanford.edu> - 0.6-2.20090920svn2334
- edit summary
- update upstream URL
- make create_server.py non-executable
- chmod src to 644

* Sun Sep 20 2009 Tim Fenn <fenn@stanford.edu> - 0.6-1.20090920svn2334
- update to 0.6
- get source from VCS system

* Wed Mar 25 2009 Tim Fenn <fenn@stanford.edu> - 0.5.2-3
- fix summary
- add additional licensing information
- split guile-extras into original tarballs

* Sat Mar 14 2009 Tim Fenn <fenn@stanford.edu> - 0.5.2-2
- fix for desktop-file-install
- gcc 4.4 patch

* Mon Dec 15 2008 Tim Fenn <fenn@stanford.edu> - 0.5.2-1
- update to 0.5.2

* Thu Nov 27 2008 Tim Fenn <fenn@stanford.edu> - 0.5-3
- use consistent buildroot
- include gtkglext-devel, guile-lib, desktop-file-utils in buildrequires
- remove pyobject2 in buildrequires

* Tue Nov 18 2008 Tim Fenn <fenn@stanford.edu> - 0.5-2
- enable guile
- include extra guile modules

* Mon Nov 17 2008 Tim Fenn <fenn@stanford.edu> - 0.5-1
- initial build
